From c8ff4f530bda14d7fc5bedb40c8afb1ac2d0fd9e Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Apr 11 2017 12:51:54 +0000
Subject: [PATCH 817/1001] Split the config panels into separate files


---

diff --git a/hubs/static/client/app/core/HubConfig.jsx b/hubs/static/client/app/core/HubConfig.jsx
index 3732bd7..fca9e33 100644
--- a/hubs/static/client/app/core/HubConfig.jsx
+++ b/hubs/static/client/app/core/HubConfig.jsx
@@ -4,12 +4,10 @@ import {
   defineMessages,
   FormattedMessage,
   } from 'react-intl';
-import {
-  GeneralPanel,
-  ChatPanel,
-  UserPanel,
-  NotImplementedPanel,
-  } from './HubConfigPanel.jsx';
+import GeneralPanel from './HubConfigPanelGeneral.jsx';
+import UserPanel from './HubConfigPanelUser.jsx';
+import ChatPanel from './HubConfigPanelChat.jsx';
+import NotImplementedPanel from './HubConfigPanelNotImpl.jsx';
 import TabSet from '../components/TabSet.jsx';
 
 
diff --git a/hubs/static/client/app/core/HubConfigPanelChat.jsx b/hubs/static/client/app/core/HubConfigPanelChat.jsx
new file mode 100644
index 0000000..458fd36
--- /dev/null
+++ b/hubs/static/client/app/core/HubConfigPanelChat.jsx
@@ -0,0 +1,106 @@
+import React from 'react';
+import {
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+
+
+const messages = defineMessages({
+  title: {
+    id: "hubs.core.config.chat.title",
+    defaultMessage: "Chat Settings",
+  },
+  intro_1: {
+    id: "hubs.core.config.chat.intro1",
+    defaultMessage: (
+      "If your team or project has an IRC channel associated with it, you "
+     +"can connect this hub to it via the Hubs chat widget."
+     ),
+  },
+  intro_2: {
+    id: "hubs.core.config.chat.intro2",
+    defaultMessage: "Please indicate your team's IRC channel below:",
+  },
+  channel_name: {
+    id: "hubs.core.config.chat.channel_name",
+    defaultMessage: "Channel name",
+  },
+  example: {
+    id: "hubs.core.config.chat.example",
+    defaultMessage: "Example:",
+  },
+  network: {
+    id: "hubs.core.config.chat.network",
+    defaultMessage: "IRC network",
+  },
+});
+
+
+export default class ChatPanel extends React.Component {
+
+  render() {
+    var networks = [],
+        channel = "#",
+        stillLoading = (
+          typeof this.props.hubConfig.chat_channel === "undefined"
+        );
+
+    if (this.props.hubConfig.chat_channel) {
+      channel = "#" + this.props.hubConfig.chat_channel.replace(/^#*/, "");
+    }
+
+    if (this.props.generalConfig.chat_networks) {
+      networks = this.props.generalConfig.chat_networks.map(
+        function(network, index) {
+          return (
+            <option value={network.domain} key={network.domain}>
+              {network.name} - {network.domain}
+            </option>
+          );
+        }.bind(this)
+      );
+    }
+
+    return (
+      <form onSubmit={(e) => {e.preventDefault();}}>
+        <FormattedMessage {...messages.title} tagName="h3" />
+        <FormattedMessage {...messages.intro_1} tagName="p" />
+        <FormattedMessage {...messages.intro_2} tagName="p" />
+        <div className="form-group">
+          <label htmlFor="hub-settings-chat-channel">
+            <FormattedMessage {...messages.channel_name} />
+          </label>
+          <input
+            type="text" className="form-control" name="chat_channel"
+            id="hub-settings-chat-channel"
+            disabled={stillLoading}
+            onChange={this.props.handleChange}
+            value={channel}
+            />
+          <p className="form-text text-muted">
+            <FormattedMessage {...messages.example} tagName="strong" />
+            <span style={{marginLeft: "0.5em"}}>#fedora-devel</span>
+          </p>
+        </div>
+        <div className="form-group">
+          <label htmlFor="hub-settings-chat-domain">
+            <FormattedMessage {...messages.network} />
+          </label>
+          <select
+            name="chat_domain" className="form-control"
+            id="hub-settings-chat-domain"
+            disabled={stillLoading}
+            onChange={this.props.handleChange}
+            value={this.props.hubConfig.chat_domain || ""}
+            >
+            {networks}
+          </select>
+        </div>
+      </form>
+    );
+  }
+
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/core/HubConfigPanelGeneral.jsx b/hubs/static/client/app/core/HubConfigPanelGeneral.jsx
new file mode 100644
index 0000000..15d53ab
--- /dev/null
+++ b/hubs/static/client/app/core/HubConfigPanelGeneral.jsx
@@ -0,0 +1,145 @@
+import React from 'react';
+import {
+  defineMessages,
+  FormattedMessage,
+  FormattedHTMLMessage,
+  } from 'react-intl';
+
+
+const messages = defineMessages({
+  title: {
+    id: "hubs.core.config.general.title",
+    defaultMessage: "General Settings",
+  },
+  intro: {
+    id: "hubs.core.config.general.intro",
+    defaultMessage: "Change your global hub parameters here.",
+  },
+  summary: {
+    id: "hubs.core.config.general.summary",
+    defaultMessage: "Summary",
+  },
+  summary_help: {
+    id: "hubs.core.config.general.summary_help",
+    defaultMessage: "This text will be displayed at the top of the hub.",
+  },
+  left_width: {
+    id: "hubs.core.config.general.left_width",
+    defaultMessage: "Left width",
+  },
+  left_width_help: {
+    id: "hubs.core.config.general.left_width_help",
+    defaultMessage: (
+      "Change the proportions of you hub's columns by setting the width of "
+     +"the left column (the right column's width will be {right_width})."
+      ),
+  },
+  visibility: {
+    id: "hubs.core.config.general.visibility",
+    defaultMessage: "Visibility",
+  },
+  visibility_help: {
+    id: "hubs.core.config.general.visibility_help",
+    defaultMessage: (
+      "Public: the hub is visible to anyone.<br />"
+     +"Private: the hub is only visible to members.<br />"
+     +"Preview: some widgets can be made visible to logged-in users only."
+      ),
+  },
+  avatar: {
+    id: "hubs.core.config.general.avatar",
+    defaultMessage: "Avatar",
+  },
+  avatar_help: {
+    id: "hubs.core.config.general.avatar_help",
+    defaultMessage: "An URL to you hub's main image or logo."
+  },
+});
+
+
+export default class GeneralPanel extends React.Component {
+
+  render() {
+    var stillLoading = (typeof this.props.hubConfig.summary === "undefined");
+    var visibilities = this.props.generalConfig.hub_visibility || [];
+    return (
+      <form onSubmit={(e) => {e.preventDefault();}}>
+        <FormattedMessage {...messages.title} tagName="h3" />
+        <FormattedMessage {...messages.intro} tagName="p" />
+        <div className="form-group">
+          <label htmlFor="hub-settings-general-summary">
+            <FormattedMessage {...messages.summary} />
+          </label>
+          <input
+            type="text" className="form-control" name="summary"
+            id="hub-settings-general-summary"
+            disabled={stillLoading}
+            onChange={this.props.handleChange}
+            value={this.props.hubConfig.summary || ""}
+            />
+          <p className="form-text text-muted">
+            <FormattedMessage {...messages.summary_help} />
+          </p>
+        </div>
+        <div className="form-group">
+          <label htmlFor="hub-settings-general-leftwidth">
+            <FormattedMessage {...messages.left_width} />
+          </label>
+          <input
+            type="number" className="form-control" name="left_width"
+            id="hub-settings-general-leftwidth"
+            disabled={stillLoading}
+            min="1" max="11"
+            onChange={this.props.handleChange}
+            value={this.props.hubConfig.left_width || ""}
+            />
+          <p className="form-text text-muted">
+            <FormattedMessage
+              {...messages.left_width_help}
+              values={{right_width: 12 - (this.props.hubConfig.left_width || 8)}}
+              />
+          </p>
+        </div>
+        <div className="form-group">
+          <label htmlFor="hub-settings-general-visibility">
+            <FormattedMessage {...messages.visibility} />
+          </label>
+          <select
+            className="form-control" name="visibility"
+            value={this.props.hubConfig.visibility || ""}
+            onChange={this.props.handleChange}
+            disabled={stillLoading}
+            >
+            {visibilities.map(function(value) {
+              return (
+                <option value={value} key={value}>{value}</option>
+                );
+            })}
+          </select>
+          <p className="form-text text-muted">
+            <FormattedHTMLMessage {...messages.visibility_help} />
+          </p>
+        </div>
+        <div className="form-group">
+          <label htmlFor="hub-settings-general-avatar">
+            <FormattedMessage {...messages.avatar} />
+          </label>
+          <input
+            type="text" className="form-control" name="avatar"
+            id="hub-settings-general-avatar"
+            disabled={stillLoading}
+            onChange={this.props.handleChange}
+            value={this.props.hubConfig.avatar || ""}
+            />
+          <p className="form-text text-muted">
+            <FormattedMessage {...messages.avatar_help} />
+          </p>
+        </div>
+      </form>
+    );
+  }
+
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/core/HubConfigPanelNotImpl.jsx b/hubs/static/client/app/core/HubConfigPanelNotImpl.jsx
new file mode 100644
index 0000000..31803be
--- /dev/null
+++ b/hubs/static/client/app/core/HubConfigPanelNotImpl.jsx
@@ -0,0 +1,17 @@
+import React from 'react';
+
+
+export default class NotImplementedPanel extends React.Component {
+
+  render() {
+    return (
+      <div>
+        Not implemented yet.
+      </div>
+    );
+  }
+
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/core/HubConfigPanelUser.jsx b/hubs/static/client/app/core/HubConfigPanelUser.jsx
new file mode 100644
index 0000000..d913c79
--- /dev/null
+++ b/hubs/static/client/app/core/HubConfigPanelUser.jsx
@@ -0,0 +1,147 @@
+import React from 'react';
+import {
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import CompletionInput from '../components/CompletionInput.jsx';
+
+
+const messages = defineMessages({
+  fullname: {
+    id: "hubs.core.config.users.fullname",
+    defaultMessage: "Full name",
+  },
+  username: {
+    id: "hubs.core.config.users.username",
+    defaultMessage: "Username",
+  },
+  change_role: {
+    id: "hubs.core.config.users.change_role",
+    defaultMessage: "Change role",
+  },
+  na: {
+    id: "hubs.core.config.users.na",
+    defaultMessage: "(N/A)",
+  },
+  remove_user: {
+    id: "hubs.core.config.users.remove_user",
+    defaultMessage: "(remove user)",
+  },
+  add_user: {
+    id: "hubs.core.config.users.add_user",
+    defaultMessage: "Add user...",
+  },
+  add: {
+    id: "hubs.core.config.users.add",
+    defaultMessage: "Add",
+  },
+});
+
+
+export default class UserPanel extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      addUsername: "",
+    };
+    this.handleAdd = this.handleAdd.bind(this);
+    this.handleAddInputChange = this.handleAddInputChange.bind(this);
+    this.handleChange = this.handleChange.bind(this);
+  }
+
+  handleAdd(e) {
+    e.preventDefault();
+    this.props.handleChange(this.state.addUsername, this.props.role);
+    this.setState({addUsername: ""});
+  }
+
+  handleAddInputChange(e) {
+    this.setState({
+      addUsername: e.target.value,
+    });
+  }
+
+  handleChange(e) {
+    e.preventDefault();
+    this.props.handleChange(e.target.name, e.target.value);
+  }
+
+  render() {
+    var users = this.props.users.map(function(user) {
+      return (
+        <tr key={user.username}>
+          <td>{user.fullname}</td>
+          <td>{user.username}</td>
+          <td>
+            {user.locked ?
+              <FormattedMessage {...messages.na} />
+            :
+              <select
+                name={user.username}
+                value={user.role}
+                className="form-control"
+                onChange={this.handleChange}
+                disabled={this.props.loading}
+                >
+                {this.props.generalConfig.roles.map(function(role) {
+                  return (
+                    <option value={role} key={role}>{role}</option>
+                    );
+                })}
+                <FormattedMessage {...messages.remove_user}>
+                  {(value) => ( <option value="">{value}</option> )}
+                </FormattedMessage>
+              </select>
+            }
+          </td>
+        </tr>
+        );
+    }.bind(this));
+
+    return (
+      <div>
+        <h3>{this.props.tabTitle}</h3>
+        <p className="text-muted">[Membership requests will be shown here]</p>
+        <hr />
+        <form className="form-inline" onSubmit={this.handleAdd}
+              style={{marginBottom: "1em"}}>
+          <div className="form-group">
+            <FormattedMessage {...messages.add_user}>
+              {(value) => (
+                <input
+                  type="text" className="form-control"
+                  name="username" placeholder={value}
+                  onChange={this.handleAddInputChange}
+                  value={this.state.addUsername}
+                  style={{marginRight: "1em"}}
+                  />
+                )}
+            </FormattedMessage>
+          </div>
+          <button className="btn btn-primary" disabled={this.props.loading}>
+            <FormattedMessage {...messages.add} />
+          </button>
+        </form>
+        {users.length !== 0 &&
+        <table className="table table-hover table-sm">
+          <thead>
+            <tr>
+              <FormattedMessage {...messages.fullname} tagName="th" />
+              <FormattedMessage {...messages.username} tagName="th" />
+              <FormattedMessage {...messages.change_role} tagName="th" />
+            </tr>
+          </thead>
+          <tbody>
+            {users}
+          </tbody>
+        </table>
+        }
+      </div>
+    );
+  }
+
+}
+
+
+// vim: set ts=2 sw=2 et:

